// Written by Dr. YIP Chi Lap [Beta]
//   for Workshop on "Computer-aided visibility measurement using digital cameras",
//   Visibility Measurement Method Design Competition,
//   Faculty of Engineering, The University of Hong Kong, 2012.

/*
   Answer to exercise (Defining a rectangle):
     Modify the program so that:
     + One corner of the rectangle to be constructed is defined
         when a mouse button is pressed

       => mousePressed() sets all of startX, startY, endX, and endY .

     + Another corner of the rectangle follows the mouse cursor
         before the mouse button is released

       => Implement mouseDragged() to update endX and endY.

     + Release of the mouse button defines the rectangle.

       => no change to mouseReleased()

     + The rectangle should be shown while it is being defined.

       => rectMode(CORNERS) and rect() are called in draw()

     + The rectangle should have a black outline and should not be filled.

       => noFill() and stroke(0)

     Note that you may need to add another function to complete the exercise.
*/


int startX = -1;
int startY = -1;
int endX   = -1;
int endY   = -1;

void setup() {
  size(600,400);
}

void draw() {
  background(255,255,192);

  rectMode(CORNERS);
  noFill();
  stroke(0);
  rect(startX, startY, endX, endY);

  println( "startX: " + startX + ", startY: " + startY +
           ", endX: " + endX + ", endY: " + endY );
}

void mousePressed() {
  startX = mouseX;
  startY = mouseY;
  endX = mouseX;
  endY = mouseY;
}

void mouseDragged() {
  endX = mouseX;
  endY = mouseY;
}

void mouseReleased() {
  endX = mouseX;
  endY = mouseY;
}
